{$A+,B-,E+,F-,G+,I-,N+,O+,P+,Q-,R-,S-,T-,V-,X+,Y-}
{****************************************************************************
 *           } Unit UScreen;{ (c) 1999 Michal Cihar                         *
 ****************************************************************************
 * Version 2.0 improvements:                                                *
 *     - rapidly speeded up by recoding to assembler (some parts 10x)       *
 *     - added variables: maxx, maxy                                        *
 *     - no other unit needed                                               *
 *     - new procedures: writearray, pause, setpausestr                     *
 *                       setborder, getborder                               *
 *     - removed global vars absolutely adressed in memory                  *
 *     - now should be runable in DPMI (not completely tested yet!)         *
 ****************************************************************************
 * CONTACT                                                                  *
 *  WWW: http://miso.fd.cz                                                  *
 *  MAIL: ciharm@fel.cvut.cz                                                *
 ****************************************************************************
 *  Procedures and functions description                                    *
 ****************************************************************************
 *     - list of WRITE commands (write to current position):                *
 *               writeint, writelnint - write via interrupt                 *
 *               write_n, writeln_n - write with no display cursor refresh  *
 *                (position is ok, only on some gr. cards is not updated on *
 *                 display) - this is a bit faster, because doesn't call    *
 *                 INT 10h)                                                 *
 *               write, writeln - write string directly into memory         *
 *               writechar - writes char, attribute direct into memory      *
 *               writecharint - writes char, attribute via INT 10h          *
 *               writeret - writes string, but doesn't move cursor          *
 *               writearray - writes aray of strings, each screen may be    *
 *                            paused                                        *
 *     - list of PUT commands (you maus specify coordinates):               *
 *               putchar - puts char, attribute                             *
 *               putline - puts row (80 chars) specified by TLine           *
 *     - coordinates                                                        *
 *               wherex, wherey - coordinates to windows (start 1,1)        *
 *               absx, absy - absolute coordinates to screen (start 1,1)    *
 *               gotoxy - set coordinates                                   *
 *               columns, rows - number of columns, rows in current mode    *
 *               winx1, winy1, winx2, winy2 - window coordinates            *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 ****************************************************************************}
{if next row is enabled then during initialisation is written message}
{{$define writeini}

{if next syymbol is defined 386 instructions are used
(currently only in putline)}
{$define USE386}
interface
const UnitID='UScreen';
      UnitCopyright='1999 Michal Cihar';
      UnitVersion='2.0';
      UnitRelease='3.2.1999';
type ScreenPoint = record {screen point}
		     Character : Char;
		     Attr : byte;
		 end;
     TLine=array[1..80] of ScreenPoint; {screen line}
{     ScreenArray = array[1..25] of TLine;{screen data}
const
 {colors}
 Black       =  0;
 Blue        =  1;
 Green       =  2;
 Cyan        =  3;
 Red         =  4;
 Magenta     =  5;
 Brown       =  6;
 LightGray   =  7;
 DarkGray    =  8;
 LightBlue   =  9;
 LightGreen  = 10;
 LightCyan   = 11;
 LightRed    = 12;
 LightMagenta= 13;
 Yellow      = 14;
 White       = 15;
 blink       =128;

const movecursor:boolean=true;
      winx1:byte=1;
      winy1:byte=1;
      winx2:byte=80;
      winy2:byte=25;

var curscreenaddr:word;                {page segment}


{INTERRUPT write(ln) - writes via interrupt
                     - NOT recomended to use this - strangely slow
                     - you have no need to use this
                     - I don't want to recode this to ASM - I don't need this
                       this stays here only because of I didn't delete this}
procedure writelnint(const s:string);
procedure writeint(const s:string);

procedure writelnattr(const s:string;const attrib:byte);

{as write(ln) but does'n preform refreshing ONLY displayed cursor - it may be
somewhere on the screen (but real cursor is ok) - a bit faster than normal
write(ln) - don't have to call INT 10h - speed up of this is about 1%}
procedure write_n(const s:string);
procedure writeln_n(const s:string);

procedure setborder(const color:byte);
function getborder:byte;


function columns:byte;
function rows:byte;

{refresh cursor - after this is allways on correct position}
procedure refresh_cursor;

{functions/procedures (the same as in CRT are not described)}
function wherex:byte;
function wherey:byte;
{absolute coordinates to screen not window}
function absx:byte;
function absy:byte;

{writes array of strings, if pausescr then after each screen pauses}
procedure writearray(var a:array of string;const pausescr:boolean);
{change pause string (string displayed while pause)}
procedure setpausestr(const s:string);
{pause - prints pause string (after key is pressed message is erased)}
procedure pause;

{current attribute (text, background)}
function curattr:byte;
{video memory segment}
function VideoModeAddr:word;
{blinking state}
function is_blinking:boolean;

{CR-LF}
procedure enter;
{2x CR-LF}
procedure enter2;
{scroll windows by number rows up (0 erases)}
procedure scrollup(const number:byte);
procedure window(const X1, Y1, X2, Y2: Byte);
procedure textcolor(const color:byte);
procedure textbackground(const color:byte);
{set cursor size}
procedure setcursor(const startline,endline:byte);
{switch cursor off}
procedure cursoroff;
{switch cursor on}
procedure cursoron;
{set video page}
procedure setpage(const num:byte);
{write char via interrupt}
procedure writecharint(const character,attr:byte);
{write char directly into memory}
procedure writechar(const character,attr:byte);
{write char into memory on coordinates x,y, doesn't move cursor}
procedure putchar(const x,y,character,attr:byte);
{write line of chars into memory on row y, doesn't move cursor}
procedure putline(const y:byte;const line:TLine);
{standart write(ln):}
procedure write(const s:string);
procedure writeln(const s:string);
{write, but doesn't move cursor}
procedure writeret(const s:string);

procedure gotoxy(const x,y:byte);
procedure clrscr;
{set blinking on/off}
procedure set_blinking(const naco:boolean);

procedure wait(microsecond_hi,microsecond_lo:word);

implementation
const curtext:byte=lightgray;
      curbackground:byte=black;

var invcursor:word;                    {saved cursor state for use in cursor on}

const pausestr:string='Press any key to continue...';
      pausespa:string='                            ';

procedure movew(var Source, Dest; Count: Word);assembler;
asm
push ds
	LDS	SI,source
	LES	DI,dest
	MOV	CX,count
@@1:	REP	MOVSw
pop ds
end;

procedure refresh_cursor;assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h] {al - current page}
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]
mov ah, 02h
mov bh, al       {current page}
int 10h
end;

function VratnZnaku(const znak:char;const pocet:byte):string;
var cykl:byte;
    vysl:string;
begin;
vysl:='';
cykl:=1;
while cykl<=pocet do
begin;
   vysl:=vysl+znak;
   inc(cykl);
end;
vratnznaku:=vysl;
end;

procedure setpausestr(const s:string);
begin;
pausestr:=s;
pausespa:=vratnznaku(' ',length(s));
end;

procedure wait(microsecond_hi,microsecond_lo:word); assembler;
asm
mov ah,86h
mov cx,microsecond_hi
mov dx,microsecond_lo
int 15h
end;


function keypressed : boolean;assembler;
asm
   mov  ax, Seg0040
   mov  es, ax
   mov  dx, es:[1ah]
   mov  bx, es:[1ch]
   xor  ax, ax
   cmp  dx, bx
   je  @end
   mov  al, 1
 @end:
end;

procedure clearbuffer;assembler;
asm
   mov  ax, Seg0040
   mov  es, ax
   mov  ax, es:[1ch]
   mov  es:[1ah], ax
end;

procedure writearray(var a:array of string;const pausescr:boolean);
var rows,index:word;
begin;
rows:=(sizeof(a) div sizeof(a[0]))-1;
for index:=0 to rows do
begin;
writeln(a[index]);
if (index>1)and(pausescr)and(((index+1) mod (winy2-winy1))=0) then pause;
end;
end;

procedure pause;
begin;
writeret(pausestr);
clearbuffer;
repeat until keypressed;
clearbuffer;
writeret(pausespa);
end;

procedure set_blinking(const naco:boolean);assembler;
asm
mov ax, 1003h
mov bl, naco
mov bh, 0
int 10h
end;

function is_blinking:boolean;assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[065h]
and al, 32
end;

function columns:byte;assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[04ah]
end;

function rows:byte;assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[084h]
inc al
end;

procedure window(const X1, Y1, X2, Y2: Byte);assembler;
asm
(* Checking removed, because it's not needed
{check and store x2}
mov ax, Seg0040
mov es, ax
mov al, es:[4ah]
mov ah, x2
cmp ah,al
ja @chyba
mov winx2, ah

{check and store y2}
mov ax, Seg0040
mov es, ax
mov al, es:[84h]
inc al
mov ah, y2
cmp ah,al
ja @chyba
mov winy2, ah*)

{store x2,y2}
mov ah, x2
mov winx2, ah
mov ah, y2
mov winy2, ah

{store x1,y1}
mov ah, y1
mov winy1, ah
mov ah, x1
mov winx1, ah

{goto 1,1}
mov dl, winx1
sub dl, 1
mov dh, winy1
sub dh, 1
{mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx
call refresh_cursor}

mov ax, Seg0040
mov es, ax
mov bh, es:[062h]
mov ah, 02h
int 10h
(*part of size checking (see upper)
mov al, 1
jmp @end
@chyba:
mov al, 0
@end:*)
end;

function VideoModeAddr:word;assembler;
asm
 {get video mode}
 mov ah, 15
 int 10h

 cmp al, 6
 je @1
 ja @2
 cmp al, 3
 je @1
 cmp al, 5
 je @1
 cmp al, 4
 je @1
 cmp al, 2
 je @1
 cmp al, 1
 je @1
 cmp al, 0
 je @1
 jmp @2
@1:
 mov ax, SegB800{0b800h}
 jmp @end
@2:
 cmp al, 10
 je @3
 ja @4
 cmp al, 9
 je @3
 cmp al, 8
 je @3
 cmp al, 7
 je @3
 jmp @4
@3:
 mov ax, SegB000{0b000h}
 jmp @end
@4:
 cmp al, 16
 je @5
 ja @end
 cmp al, 15
 je @5
 cmp al, 14
 je @5
 cmp al, 13
 je @5
 cmp al, 12
 je @5
 cmp al, 11
 je @5
 jmp @end
@5:
 mov ax, SegA000{0a000h}
@end:
end;

function curattr:byte;assembler;
asm
mov al, curbackground
shl al, 4
add al, curtext
end;

procedure textcolor(const color:byte);assembler;
asm
mov ah, color
mov curtext, ah
end;

procedure textbackground(const color:byte);assembler;
asm
mov ah, color
mov curbackground, ah
end;

procedure setcursor(const startline,endline:byte); assembler;
asm
mov ah, 01h
mov ch, startline
mov cl, endline
int 10h
end;

procedure cursoroff; assembler;
asm
mov ah, 03h
int 10h
mov invcursor, cx
mov ah, 01h
mov cx, 8192
int 10h
end;

procedure cursoron; assembler;
asm
mov ah, 01h
mov cx, invcursor
int 10h
end;

function wherex:byte; assembler;
asm
{mov ah, 03h
mov bh, curpage
int 10h}
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]

add dl, 2
sub dl, winx1
mov al, dl
end;

function wherey:byte; assembler;
asm
{mov ah, 03h
mov bh, curpage
int 10h}
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]

add dh, 2
sub dh, winy1
mov al, dh
end;

function absx:byte;assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]
{mov ah, 03h
mov bh, curpage
int 10h}
inc dl
mov al, dl
end;

function absy:byte;assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]
{mov ah, 03h
mov bh, curpage
int 10h}
inc dh
mov al, dh
end;

procedure scrolloneupnomove;assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]
{mov ah, 03h
mov bh, curpage
int 10h}
push dx

mov ah, 06h
mov al, 1
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
sub ch, 1
mov cl, winx1
sub cl, 1
mov dh, winy2
sub dh, 1
mov dl, winx2
sub dl, 1
int 10h

pop dx
dec dh
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx
{mov ah, 02h
mov bh, curpage
int 10h}

end;

procedure scrolloneup;assembler;
asm
mov ah, 06h
mov al, 1
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
sub ch, 1
mov cl, winx1
sub cl, 1
mov dh, winy2
sub dh, 1
mov dl, winx2
sub dl, 1
int 10h
end;

procedure scrollup(const number:byte);assembler;
asm
mov ah, 06h
mov al, number
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
sub ch, 1
mov cl, winx1
sub cl, 1
mov dh, winy2
sub dh, 1
mov dl, winx2
sub dl, 1
int 10h
end;

procedure gotoxy(const x,y:byte);assembler;
asm
mov ah, x
mov al, winx2
add al, 1
sub al, winx1
cmp ah, al
jbe @02
@01:
sub ah,al
inc y
cmp ah,al
ja @01
@02:
mov dl, ah
add dl, winx1
sub dl, 2

mov ah, y
mov al,winy2
add al, 1
sub al, winy1
cmp ah,al
jbe @04
@03:
dec ah
push dx
push ax
call scrolloneup
pop ax
pop dx
cmp ah,al
ja @03
@04:
mov dh, ah
add dh, winy1
sub dh, 2

mov ax, Seg0040
mov es, ax
{mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx}
mov ah, 02h
mov bh, es:[062h]
int 10h
{call refresh_cursor}
end;

procedure writecharint(const character,attr:byte);assembler;
asm
mov ax, Seg0040
mov es, ax
mov ah, 09h
mov al, character
mov bh, es:[062h]
mov bl, attr
mov cx, 1
int 10h

mov cl,0
mov ch, movecursor
jcxz @end

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]
{mov ah, 03h
mov bh, curpage
int 10h
{dl - x, dh - y}

inc dl {we need x+1}

mov al, winx2
dec al {my coordinates start is 1, but BIOS 0}
cmp dl, al
jbe @02
mov dl, winx1
dec dl
inc dh
@02:

mov al,winy2
dec al
cmp dh,al
jbe @04
dec dh
push dx
push ax
call scrolloneup
pop ax
pop dx
@04:

{mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx}
mov ax, Seg0040
mov es, ax
mov bh, es:[062h]
mov ah, 02h
int 10h
{mov ah, 02h
mov bh, curpage
int 10h}

@end:
{call refresh_cursor}
end;

procedure movecur_; assembler;
{moves cursor if movecursor is true}
asm
mov cl,0
mov ch, movecursor
jcxz @end

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]
{mov ah, 03h
mov bh, curpage
int 10h
{dl - x, dh - y}

inc dl {we need x+1}

mov al, winx2
dec al {my coordinates start is 1, but BIOS 0}
cmp dl, al
jbe @02
mov dl, winx1
dec dl
inc dh
@02:

mov al,winy2
dec al
cmp dh,al
jbe @04
dec dh
push dx
push ax
call scrolloneup
pop ax
pop dx
@04:

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx
{mov ah, 02h
mov bh, curpage
int 10h}

@end:
end;

procedure writechar(const character,attr:byte);assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]


mov  ax, Seg0040
mov  es, ax
mov  bh, es:[4ah] {BH - columns}
mov  bl, es:[84h] {BL - max row}

mov al, dh
mov ah, 0
mov cl, dl
mov ch, 0
mul bh
add ax,cx {AX=x+columns*y}
shl ax,1

push ax
mov  ax, Seg0040
mov  es, ax
mov  bx, es:[4eh] {BX - page offset}
pop ax
add bx, ax  {BX - current position offset}

mov ax, curscreenaddr
mov es, ax {ES  - segment}


mov al, character
mov ah, attr

mov es:[bx], ax  {putchar}

{*****************************************************************************
call movecur_}
cmp movecursor, 0
jz @05

inc dl {we need x+1}

mov al, winx2
dec al {my coordinates start is 1, but BIOS 0}
cmp dl, al
jbe @02
mov dl, winx1
dec dl
inc dh
@02:

mov al,winy2
dec al
cmp dh,al
jbe @04
dec dh
push dx
{******************************************************************************
call scrolloneup}
mov ax, 0601h
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
dec ch
mov cl, winx1
dec cl
mov dh, winy2
dec dh
mov dl, winx2
dec dl
int 10h

{end scroloneup ***************************************************************}
pop dx
@04:

mov ax, Seg0040
mov es, ax
mov bh, es:[062h]
mov ah, 02h
int 10h


@05:
end;

procedure putchar(const x,y,character,attr:byte);assembler;
asm
mov dh, y
mov dl, x
dec dl
dec dh

mov  ax, Seg0040
mov  es, ax
mov  bh, es:[4ah] {BH - columns}
mov  bl, es:[84h] {BL - max row}

mov al, dh
mov ah, 0
mov cl, dl
mov ch, 0
mul bh
add ax,cx {AX=x+columns*y}
shl ax,1

push ax
mov  ax, Seg0040
mov  es, ax
mov  bx, es:[4eh] {BX - page offset}
pop ax
add bx, ax  {BX - current position offset}

mov ax, curscreenaddr
mov es, ax {ES  - segment}


mov al, character
mov ah, attr

mov es:[bx], ax  {putchar}
end;

procedure putline(const y:byte;const line:TLine);assembler;
asm
mov dh ,y
dec dh
xor dl, dl

mov  ax, Seg0040
mov  es, ax
mov  bh, es:[4ah] {BH - columns}

mov al, dh
mov ah, 0
mul bh
shl ax,1   {AX=colums*y*2}

les si, line
{$IFDEF USE386}
mov cx, 40 {cx - length s (in Dwords)}
{$ELSE}
mov cx, 80 {cx - length s (in words)}
{$ENDIF}
mov dx, es

push ax
mov  ax, Seg0040
mov  es, ax
mov  di, es:[4eh] {di - page offset}
pop ax
add di, ax  {di - current position offset}


mov ax, curscreenaddr
mov es, ax {ES  - segment}

push ds
mov ds, dx

{$IFDEF USE386}
  db    0F3h,66h,0A5h{rep movsd}
{$ELSE}
rep movsw
{$ENDIF}

{@loop:
lodsw
stosw
loop @loop}

@end:
pop ds
end;

procedure writeret(const s:string);assembler;
var scrolled:byte;
asm
mov byte ptr scrolled, 0

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]
push dx

les bx, s
mov cl, es:[bx] {cL - length s}
mov ch, 0
cmp cl,0
je @end


@loop:
push cx

mov  ax, Seg0040
mov  es, ax
mov  bh, es:[4ah] {BH - columns}
mov  bl, es:[84h] {BL - max row}

mov al, dh
mov ah, 0
mov cl, dl
mov ch, 0
mul bh
add ax,cx {AX=x+columns*y}
shl ax,1

push ax
mov  ax, Seg0040
mov  es, ax
mov  bx, es:[4eh] {BX - page offset}
pop ax
add bx, ax  {BX - current position offset}

mov ax, curscreenaddr
mov es, ax {ES  - segment}

{get char from string}
pop cx
push es
push dx
push bx

les bx, s
mov dl, ch
inc dl
mov dh, 0
add bx, dx
mov al, es:[bx]{al - char to write}

pop bx
pop dx
pop es

mov ah, curbackground
shl ah, 4
add ah, curtext {Ah - color attribute}

mov es:[bx], ax
add bx, 2
inc ch   {counter}

push bx
push es
push cx
{*****************************************************************************
call movecur_}
cmp movecursor, 0
jz @05

inc dl {we need x+1}

mov al, winx2
dec al {my coordinates start is 1, but BIOS 0}
cmp dl, al
jbe @02
mov dl, winx1
dec dl
inc dh
@02:

mov al,winy2
dec al
cmp dh,al
jbe @04
dec dh
push dx
{******************************************************************************
call scrolloneup}
mov ax, 0601h
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
dec ch
mov cl, winx1
dec cl
mov dh, winy2
dec dh
mov dl, winx2
dec dl
int 10h
inc scrolled

{end scroloneup ***************************************************************}
pop dx
@04:

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx


@05:
{end movecur *****************************************************************}
pop cx
pop es
pop bx
cmp ch, cl
jb @loop
@end:

pop dx {restore cursor coordinates}

sub dh, scrolled

mov ax, Seg0040
mov es, ax
mov bh, es:[062h]
mov ah, 02h
int 10h

{call refresh_cursor}
end;

procedure writeint(const s:string);
var i:byte;
    attr:byte;
    delka:byte;
begin;
attr:=curattr;
delka:=length(s);
for i:=1 to delka do writecharint(ord(s[i]),attr);
end;

procedure write(const s:string);assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]

push ds
lds si, s
lodsb
mov cl, al
mov di, ds
pop ds
xor ch, ch
cmp cl,0
je @end


@loop:
push cx

mov  ax, Seg0040
mov  es, ax
mov  bh, es:[4ah] {BH - columns}
mov  bl, es:[84h] {BL - max row}

mov al, dh
mov ah, 0
mov cl, dl
mov ch, 0
mul bh
add ax,cx {AX=x+columns*y}
shl ax,1

push ax
mov  ax, Seg0040
mov  es, ax
mov  bx, es:[4eh] {BX - page offset}
pop ax
add bx, ax  {BX - current position offset}

mov ax, curscreenaddr
mov es, ax {ES  - segment}

pop cx
{get char from string}
push ds
mov ds, di
lodsb
pop ds

mov ah, curbackground
shl ah, 4
add ah, curtext {Ah - color attribute}

mov es:[bx], ax
inc ch   {counter}

push cx
{*****************************************************************************
call movecur_}
cmp movecursor, 0
jz @05

inc dl {we need x+1}

mov al, winx2
dec al {my coordinates start is 1, but BIOS 0}
cmp dl, al
jbe @02
mov dl, winx1
dec dl
inc dh
@02:

mov al,winy2
dec al
cmp dh,al
jbe @04
dec dh
push dx
{******************************************************************************
call scrolloneup}
mov ax, 0601h
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
dec ch
mov cl, winx1
dec cl
mov dh, winy2
dec dh
mov dl, winx2
dec dl
int 10h

{end scroloneup ***************************************************************}
pop dx
@04:

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx


@05:
{end movecur *****************************************************************}
pop cx
cmp ch, cl
jb @loop
@end:
mov ax, Seg0040
mov es, ax
mov bh, es:[062h] {bh - current page}
mov ah, 02h
int 10h
end;

procedure write_n(const s:string);assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]

push ds
lds si, s
lodsb
mov cl, al
mov di, ds
pop ds
xor ch, ch
cmp cl,0
je @end


@loop:
push cx

mov  ax, Seg0040
mov  es, ax
mov  bh, es:[4ah] {BH - columns}
mov  bl, es:[84h] {BL - max row}

mov al, dh
mov ah, 0
mov cl, dl
mov ch, 0
mul bh
add ax,cx {AX=x+columns*y}
shl ax,1

push ax
mov  ax, Seg0040
mov  es, ax
mov  bx, es:[4eh] {BX - page offset}
pop ax
add bx, ax  {BX - current position offset}

mov ax, curscreenaddr
mov es, ax {ES  - segment}

pop cx
{get char from string}
push ds
mov ds, di
lodsb
pop ds

mov ah, curbackground
shl ah, 4
add ah, curtext {Ah - color attribute}

mov es:[bx], ax
inc ch   {counter}

push cx
{*****************************************************************************
call movecur_}
cmp movecursor, 0
jz @05

inc dl {we need x+1}

mov al, winx2
dec al {my coordinates start is 1, but BIOS 0}
cmp dl, al
jbe @02
mov dl, winx1
dec dl
inc dh
@02:

mov al,winy2
dec al
cmp dh,al
jbe @04
dec dh
push dx
{******************************************************************************
call scrolloneup}
mov ax, 0601h
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
dec ch
mov cl, winx1
dec cl
mov dh, winy2
dec dh
mov dl, winx2
dec dl
int 10h

{end scroloneup ***************************************************************}
pop dx
@04:

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx


@05:
{end movecur *****************************************************************}
pop cx
cmp ch, cl
jb @loop
@end:
end;

procedure clrscr;assembler;
asm
mov ax, 0600h
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
sub ch, 1
mov cl, winx1
sub cl, 1
mov dh, winy2
sub dh, 1
mov dl, winx2
sub dl, 1
int 10h

{now goto 1,1:}
mov dl, winx1
sub dl, 1

mov dh, winy1
sub dh, 1

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx
{mov ah, 02h
mov bh, curpage
int 10h}

end;

procedure enter;assembler;
asm;
{get y+1+winy1}
{mov ah, 03h
mov bh, curpage
int 10h}
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]
add dh, 3

{get maxy+winy1}
mov al,winy2
add al, 1
cmp dh,al
jbe @04
@03:
dec dh
push dx
push ax
call scrolloneup
pop ax
pop dx
cmp dh,al
ja @03
@04:

sub dh, 2
mov dl,winx1
dec dl
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx
{mov ah, 02h
mov bh, curpage
int 10h}
end;

procedure enter2;assembler;
asm;
{get y+2+winy1}
{mov ah, 03h
mov bh, curpage
int 10h}
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]
add dh, 4

{get maxy+winy1}
mov al,winy2
add al, 1
cmp dh,al
jbe @04
@03:
dec dh
push dx
push ax
call scrolloneup
pop ax
pop dx
cmp dh,al
ja @03
@04:

sub dh, 2
mov dl,winx1
dec dl
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx
{mov ah, 02h
mov bh, curpage
int 10h}
end;

procedure writelnint(const s:string);
var i:byte;
    attr:byte;
    delka:byte;
begin;
attr:=curattr;
delka:=length(s);
for i:=1 to delka do writecharint(ord(s[i]),attr);
enter;
end;

procedure writelnattr(const s:string;const attrib:byte);assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]

push ds
lds si, s
lodsb
mov cl, al
mov di, ds
pop ds
xor ch, ch
cmp cl,0
je @end


@loop:
push cx

mov  ax, Seg0040
mov  es, ax
mov  bh, es:[4ah] {BH - columns}
mov  bl, es:[84h] {BL - max row}

mov al, dh
mov ah, 0
mov cl, dl
mov ch, 0
mul bh
add ax,cx {AX=x+columns*y}
shl ax,1

push ax
mov  ax, Seg0040
mov  es, ax
mov  bx, es:[4eh] {BX - page offset}
pop ax
add bx, ax  {BX - current position offset}

mov ax, curscreenaddr
mov es, ax {ES  - segment}

pop cx
{get char from string}
push ds
mov ds, di
lodsb
pop ds

{mov ah, curbackground
shl ah, 4
add ah, curtext {Ah - color attribute}
mov ah, attrib

mov es:[bx], ax
inc ch   {counter}

push cx
{*****************************************************************************
call movecur_}
cmp movecursor, 0
jz @05

inc dl {we need x+1}

mov al, winx2
dec al {my coordinates start is 1, but BIOS 0}
cmp dl, al
jbe @02
mov dl, winx1
dec dl
inc dh
@02:

mov al,winy2
dec al
cmp dh,al
jbe @04
dec dh
push dx
{******************************************************************************
call scrolloneup}
mov ax, 0601h
{mov bh, curbackground
shl bh, 4
add bh, curtext}
mov bh, attrib
mov ch, winy1
dec ch
mov cl, winx1
dec cl
mov dh, winy2
dec dh
mov dl, winx2
dec dl
int 10h

{end scroloneup ***************************************************************}
pop dx
@04:

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx


@05:
{end movecur *****************************************************************}
pop cx
cmp ch, cl
jb @loop
@end:
{********************
call enter}
add dh, 3 {?????????????????????????}

{get maxy+winy1}
mov al,winy2
add al, 1
cmp dh,al
jbe @004
@003:
dec dh
push dx
push ax
call scrolloneup
pop ax
pop dx
cmp dh,al
ja @003
@004:

sub dh, 2
mov dl,winx1
dec dl      {dx - needed cursor position}
mov ax, Seg0040
mov es, ax
mov bh, es:[062h] {bh - current page}
mov ah, 02h
int 10h
end;

procedure writeln(const s:string);assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]

push ds
lds si, s
lodsb
mov cl, al
mov di, ds
pop ds
xor ch, ch
cmp cl,0
je @end


@loop:
push cx

mov  ax, Seg0040
mov  es, ax
mov  bh, es:[4ah] {BH - columns}
mov  bl, es:[84h] {BL - max row}

mov al, dh
mov ah, 0
mov cl, dl
mov ch, 0
mul bh
add ax,cx {AX=x+columns*y}
shl ax,1

push ax
mov  ax, Seg0040
mov  es, ax
mov  bx, es:[4eh] {BX - page offset}
pop ax
add bx, ax  {BX - current position offset}

mov ax, curscreenaddr
mov es, ax {ES  - segment}

pop cx
{get char from string}
push ds
mov ds, di
lodsb
pop ds

mov ah, curbackground
shl ah, 4
add ah, curtext {Ah - color attribute}

mov es:[bx], ax
inc ch   {counter}

push cx
{*****************************************************************************
call movecur_}
cmp movecursor, 0
jz @05

inc dl {we need x+1}

mov al, winx2
dec al {my coordinates start is 1, but BIOS 0}
cmp dl, al
jbe @02
mov dl, winx1
dec dl
inc dh
@02:

mov al,winy2
dec al
cmp dh,al
jbe @04
dec dh
push dx
{******************************************************************************
call scrolloneup}
mov ax, 0601h
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
dec ch
mov cl, winx1
dec cl
mov dh, winy2
dec dh
mov dl, winx2
dec dl
int 10h

{end scroloneup ***************************************************************}
pop dx
@04:

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx


@05:
{end movecur *****************************************************************}
pop cx
cmp ch, cl
jb @loop
@end:
{********************
call enter}
add dh, 3 {?????????????????????????}

{get maxy+winy1}
mov al,winy2
add al, 1
cmp dh,al
jbe @004
@003:
dec dh
push dx
push ax
call scrolloneup
pop ax
pop dx
cmp dh,al
ja @003
@004:

sub dh, 2
mov dl,winx1
dec dl      {dx - needed cursor position}
mov ax, Seg0040
mov es, ax
mov bh, es:[062h] {bh - current page}
mov ah, 02h
int 10h
end;

procedure writeln_n(const s:string);assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov dx, es:[bx]

push ds
lds si, s
lodsb
mov cl, al{cL - length s}
mov di, ds{di:si - s[1]}
pop ds
xor ch, ch
cmp cl,0
je @end


@loop:
push cx

mov  ax, Seg0040
mov  es, ax
mov  bh, es:[4ah] {BH - columns}
mov  bl, es:[84h] {BL - max row}

mov al, dh
mov ah, 0
mov cl, dl
mov ch, 0
mul bh
add ax,cx {AX=x+columns*y}
shl ax,1

push ax
mov  ax, Seg0040
mov  es, ax
mov  bx, es:[4eh] {BX - page offset}
pop ax
add bx, ax  {BX - current position offset}

mov ax, curscreenaddr
mov es, ax {ES  - segment}

pop cx
{get char from string}
push ds
mov ds, di
lodsb
pop ds

mov ah, curbackground
shl ah, 4
add ah, curtext {Ah - color attribute}

mov es:[bx], ax
inc ch   {counter}

push cx
{*****************************************************************************
call movecur_}
cmp movecursor, 0
jz @05

inc dl {we need x+1}

mov al, winx2
dec al {my coordinates start is 1, but BIOS 0}
cmp dl, al
jbe @02
mov dl, winx1
dec dl
inc dh
@02:

mov al,winy2
dec al
cmp dh,al
jbe @04
dec dh
push dx
{******************************************************************************
call scrolloneup}
mov ax, 0601h
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
dec ch
mov cl, winx1
dec cl
mov dh, winy2
dec dh
mov dl, winx2
dec dl
int 10h

{end scroloneup ***************************************************************}
pop dx
@04:

mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx


@05:
{end movecur *****************************************************************}
pop cx
cmp ch, cl
jb @loop
@end:
{*****************
call enter}
add dh, 3

{get maxy+winy1}
mov al,winy2
add al, 1
cmp dh,al
jbe @004
@003:
dec dh
push dx
push ax
{-*******************
call scrolloneup}
mov ax, 0601h
mov bh, curbackground
shl bh, 4
add bh, curtext
mov ch, winy1
dec ch
mov cl, winx1
dec cl
mov dh, winy2
dec dh
mov dl, winx2
dec dl
int 10h
{end scrolloneup}
pop ax
pop dx
cmp dh,al
ja @003
@004:

sub dh, 2
mov dl,winx1
dec dl
mov ax, Seg0040
mov es, ax
mov al, es:[062h]
xor ah, ah
shl ax, 1
mov bx, ax
add bx, 050h
mov es:[bx], dx
{end enter}
end;

procedure setpage(const num:byte);assembler;
asm
mov ax, Seg0040
mov es, ax
mov al, num
mov es:[062h],al
mov ah, 05h
int 10h
end;

procedure setborder(const color:byte);assembler;
asm
mov bh, color
mov ax, 1001h
int 10h
end;

function getborder:byte;assembler;
asm
mov ax, 1008h
int 10h
mov al, bh
end;

begin;
{$ifdef writeini}
system.write('Wait please initializing unit ',unitid,#13);
{$endif}
asm

{initialises cursor routines}
{set cursor}
mov ah, 01h
mov ch, 7
mov cl, 8
int 10h

{get cursor}
mov ah, 03h
int 10h
mov invcursor, cx

{set video page 0}
mov ax, Seg0040
mov es, ax
mov al, 0
mov es:[062h],al
mov ah, 05h
int 10h

{now get current screen attributes}
mov ax, Seg0040
mov es, ax
mov ah, 8
mov bh, es:[062h]
int 10h
mov al, ah
shr al, 4
mov curbackground, al
shl ah, 4
shr ah, 4
mov curtext, ah

 {get video mode}
 mov ah, 15
 int 10h

 cmp al, 6
 je @1
 ja @2
 cmp al, 3
 je @1
 cmp al, 5
 je @1
 cmp al, 4
 je @1
 cmp al, 2
 je @1
 cmp al, 1
 je @1
 cmp al, 0
 je @1
 jmp @2
@1:
 mov ax, SegB800{0b800h}
 jmp @6
@2:
 cmp al, 10
 je @3
 ja @4
 cmp al, 9
 je @3
 cmp al, 8
 je @3
 cmp al, 7
 je @3
 jmp @4
@3:
 mov ax, SegB000{0b000h}
 jmp @6
@4:
 cmp al, 16
 je @5
 ja @6
 cmp al, 15
 je @5
 cmp al, 14
 je @5
 cmp al, 13
 je @5
 cmp al, 12
 je @5
 cmp al, 11
 je @5
 jmp @7
@5:
 mov ax, SegA000{0a000h}
@7: {mode not known - so set mode 3}
 mov ah, 0
 mov al, 3
 int 10h
 mov ax, SegB800
@6:
mov curscreenaddr, ax
end;
{$ifdef writeini}
system.writeln('Unit ',unitid,' version ',unitversion,' (c) ',unitcopyright,' initialized.');
{$endif}
end.
do you thing this source code is chaotic?





ok, it's, but I don't like commenting source code much





if you don't like make some comments for me :-)